# urdf and xacro files

The xacro files are created manually and used to create the moveit package.

The urdf files are created from the xacro to be used by pyBullet.

### Creating urdf for pyBullet

Source ros and the catkin workspace containing this package and `ur_e_description`.

```bash
rosrun xacro xacro -o 2arm.urdf 2arm.xacro
rosrun xacro xacro -o table.urdf table.xacro
rosrun xacro xacro -o un5e.urdf ../../universal_robot/ur_e_description/urdf/ur5e_robot.urdf.xacro
```

This cannot be used by pyBullet yet.
pyBullet cannot use dae files and is not able to handle ros package references.

To fix this, perform the following find and replaces where necessary:
- `package:/` -> `../../universal_robot`
- `/visual/` -> `/collision/`
- `.dae` -> `.stl`

**Note**: The collision stls are used for visualisation.
The path to the stls between packages is hardcoded - this should be fixed at some point



